<?php
require_once "PDQ.php";

function Purify($s, $n = 0)
{
    if ($n > 0)
    {
        return trim(substr(trim(trim(trim($s),"\"\'")),0,$n));
    } else {
        return trim(trim(trim($s),"\"\'"));
    };
}

function UpPurify($s, $n = 0)
{
    return strtoupper(Purify($s,$n));
}

function help()
{
 printf("\nAvailable commands:\n\n");
 printf(" INIT <sps>\n");
 printf("    Where <sps> is the model name.\n\n");
 printf(" CREATEOPEN <s> <f>\n");
 printf("    Where <s> is the workload name and <f> is the arrival rate per unit time\n");
 printf("    into queueing circuit.\n\n");
 printf(" CREATECLOSED <s> < BATCH | TERM > <f1> <f2>\n");
 printf("    Where <s> is the workload name, <f1> is the number of requests or customer\n"); 
 printf("    population  active in  the closed queueing  circuit, <f2>  is the delay or\n");
 printf("    think-time, before the request reenters the queueing circuit.\n\n"); 
 printf(" CREATENODE <s> < CEN | DLY > < FCFS | FIFO | ISRV |IS | LCFS | LIFO | PSHR | PS >\n");
 printf("    Where <s> is the name used to identify the node.\n\n"); 
 printf(" SETDEMAND <s1> <s2> <f>\n");
 printf("    Where <s1> is the node name, <s2> is the workload name and <f> is the service\n");
 printf("    demand (in units of time) required by the workload at that node.\n\n"); 
 printf(" SETVISITS <s1> <s2> <f1> <f2>\n");
 printf("    Where <s1> is the node name, <s2> is the workload name, <f1> is the number\n");
 printf("    of visits to that node (dimensionless), <f2> is the service time the workload\n"); 
 printf("    requires at that node (in time units).\n\n"); 
 printf(" SETWUNIT <s>\n");
 printf("    Where <s> is the name of the work unit (default is \"Job\").\n\n");
 printf(" SETTUNIT <s>\n");
 printf("    Where <s> is the name of the time unit (default is \"Sec\").\n\n");
 printf(" SETDEBUG < TRUE | FALSE >\n");
 printf("    Activate the debug mode of PDQ Library.\n\n");
 printf(" SOLVE < APPROX | CANON | EXACT >\n");
 printf("    Solve the model according to the passed solution method.\n\n");
 printf(" GETRESPONSE < TRANS | TERM | BATCH > <s>\n");
 printf("    Is used to determine the system response time for the <s> workload.\n\n");
 printf(" GETTHRUPUT < TRANS | TERM | BATCH > <s>\n");
 printf("    Is used to determine the system thruput time for the <s> workload.\n\n");
 printf(" GETUTILIZATION <s1> <s2>\n");
 printf("    Is used to determine the utilization of the designated queueing node <s1>\n");
 printf("    by the specified workload <s2>.\n\n");
 printf(" REPORT\n");
 printf("    Print out a formatted report of the analisys.\n\n");
 printf(" HELP\n");
 printf("    Show this help.\n\n");
 printf(" EXTHELP\n");
 printf("    Show extended command help.\n\n");
 printf(" EXIT\n");
 printf("    Quit PDQ Shell.\n\n");
 printf("Note:\n");
 printf(" <sps> = A string that can contain space characters;\n");
 printf(" <s.*> = A string that can't contain space characters;\n");
 printf(" <f.*> = A real/floating point number or a well defined variable name;\n");
 printf(" <c.*> = A constant string value.\n");
 printf("\nWhen in interactive mode PDQ Shell output messages always begin with \">>\"\nthe other message come from PDQ Library\n");
 printf("\n");
}

function exthelp()
{
 printf("\nAvailable extended commands:\n\n");
 printf(" [SN|SETNAME] <sps>\n");
 printf("    Change the model name to <sps> without reinitialize PDQ.\n\n");
 printf(" PROMPT < ON | OFF | DEFAULT | COMPLETE | <sps> >\n");
 printf("    Change the default prompt to <sps>, default \"PDQ> \",\n");
 printf("    complete with \"> \" or put prompt OFF or ON.\n\n");
 printf(" [MESSAGE|MESSAGES|SHOWMESSAGE] < ON | OFF >\n");
 printf("    Show or hide PDQ Shell execution messages.\n\n");
 printf(" [ERROR|ERRORS|SHOWERROR] < ON | OFF >\n");
 printf("    Show or hide PDQ Shell execution error.\n\n");
 printf(" [ECHO|PRINT] <sps>\n");
 printf("    Print the <sps> string.\n\n");
 printf(" [ECHON|PRINTN] <sps>\n");
 printf("    Print the <sps> string and go to new line.\n\n");
 printf(" [VER|VERSION]\n");
 printf("    Print out the PDQ Library version.\n\n");
 printf(" [VAR|INT|INTEGER|DOUBLE|REAL|FLOAT] <s> = <f>\n");
 printf("    Define a variable named <s> initialized with value <f>.\n\n");
 printf(" [GETVAR|PRINTV|PRINTVAR|VARSHOW|SHOWVAR] <s>\n");
 printf("    Print out the value of variable <s> (whitout going to new line when in stream mode)\n\n");
 printf(" [HIST|HISTORY|SHOWHIST]\n");
 printf("    Print out the history of sucefully executed commands.\n\n");
 printf(" [CLEARHIST|CLEARHISTORY]\n");
 printf("    Clear History.\n\n");
 printf(" VARSTAT <s>\n");
 printf("    Show al defined variables and it's values in interactive mode.\n\n");
 printf(" ERLANG <f1> <f2>\n");
 printf("    Compute Erlang-B and Erlang-C function for <f1> servers and <f2> traffic intensity.\n\n");
 printf(" REPAIR <f1> <f2> <f3> <f4>\n");
 printf("    Compute the exact solution for M/M/m/N/N repairmen model\n");
 printf("    where <f1> = Number of servicemen, <f2> = Mean service time,\n");
 printf("    <f3> = Number of machines, <f4> = Mean time to failure (MTTF).\n\n");
 printf("Available commands alias :\n\n");
 printf(" [CO|COPEN] aliases of CREATEOPEN\n");
 printf(" [CC|CCLOSED] aliases of CREATECLOSED\n");
 printf(" [CN|CNODE] aliases of CREATENODE\n");
 printf(" [SD|SDEMAND] aliases of SETDEMAND\n");
 printf(" [SV|SVISIT] aliases of SETVISIT\n");
 printf(" [SW|SWU|SWUNIT|SETWORKUNIT] aliases of SETWUNIT\n");
 printf(" [ST|STU|STUNIT|SETTIMEUNIT] aliases of SETTUNIT\n");
 printf(" [DBG|SDBG|SDEBUG] aliases of SETDEBUG\n");
 printf(" [?|H] aliases of HELP\n");
 printf(" [??|HH] aliases of EXTHELP\n");
 printf(" [XIT|END|BYE|LOGOUT|QUIT] aliases of EXIT\n");
 printf(" COMPUTE alias of SOLVE\n");
 printf(" GR alias of GETRESPONSE\n");
 printf(" GU alias of GETUTILIZATION\n");
 printf(" GT alias of GETTHRUPUT\n");
 printf(" REP alias of REPORT\n");
 printf("\n");
};

function main(&$argc, &$argv)
{
    global $PDQ_model, $PDQ_prev_init, $PDQ_typetable, $PDQ_nodes, $PDQ_streams;
    
    $notstdin = FALSE;
    
    $hist = "";
    
    $fin = STDIN;                    
    
    $schedpol = array("FCFS","FIFO","ISRV","IS","LCFS","LIFO","PSHR","PS");
    
    $PML_Vars = array();
    
    $PDQSprompt = "PDQ> ";
    
    if ($argc > 1) {
        $showprompt = FALSE;
        $showmessage = FALSE;
        if (($argv[1] == "-s") && ($argc > 2))
        {
            if (file_exists($argv[2])) {
                $fin = fopen($argv[2], "r");
                $notstdin = TRUE;
            } else {
                $showprompt = TRUE;
                $showmessage = TRUE;
                printf("\nPDQ SHELL CRITICAL ERROR: File not found!\n");
            };
        //} else if (($argv[1] == "-s") && ($argc == 2)) {
            // do nothing
        //} else {
        } else if (($argv[1] != "-s") && ($argc == 2)) {
            if (file_exists($argv[1])) {
                $fin = fopen($argv[1], "r");
                $notstdin = TRUE;
            } else {
                $showprompt = TRUE;
                $showmessage = TRUE;
                printf("\nPDQ SHELL CRITICAL ERROR: File not found!\n");
            };
        }; 
    } else {
        $showprompt = TRUE;
        $showmessage = TRUE;
    };
    
    $showerror = TRUE;
    $ca = array();
    if ($showmessage) {
        printf("\nPDQ (Pretty Damn Quick) Performance Analyzer Shell V 1.0\n");
        printf("Created by Samuel Zallocco - University of L'Aquila - ITALY\n");
        printf("Using Library: %s\n\n",PDQ_GetVersion());
        printf("Type HELP for available commands description.\n\n");
    };


    $PML_Vars["CREATEOPENCOUNT"] = 0;
    $PML_Vars["CREATECLOSEDCOUNT"] = 0;
    $PML_Vars["CREATENODECOUNT"] = 0;
    $PML_Vars["RESPONSE"] = 0;
    $PML_Vars["THRUPUT"] = 0;
    $PML_Vars["UTILIZATION"] = 0;

    $comm = "";
    $solved = FALSE;
    $infiniteloop = 0;
    while ($comm !=  "EXIT")
    {
        if ($showprompt) printf($PDQSprompt);
        
        $PML_Vars["NODES"] = $PDQ_nodes;
        $PML_Vars["STREAMS"] = $PDQ_streams;
        
        $ca = fscanf($fin, "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s\n");
        $cas = "";
        $commentfound = FALSE;
        for ($i = 1; $i<count($ca); $i++)
        {
          if (in_array(substr(trim($ca[$i]),0,2),array("//","/*","#"))) $commentfound = TRUE; 
          if (!$commentfound) $cas .= $ca[$i]." ";
        };
        $comm = strtoupper($ca[0]);
        switch($comm)
        {
            case "INIT":
                    $s = Purify($cas,MAXCHARS);
                    if ($s != "")
                    {
                      PDQ_Init($s);
                      $hist .= sprintf("INIT \"%s\"\n",$s);
                      $solved = FALSE;
                      $PDQSprompt = "PDQ>".$s."> ";
                      if ($showmessage) {
                            printf("  >> OK: Model Initialized\n",$s);
                            printf("  >>     Name set to: \"%s\"\n",$s);
                      };
                    } else {
                      if ($showerror) printf("  >> ERROR: Invalid or empty model name!\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "SN":
            case "SETNAME":
                    $s = Purify($cas,MAXCHARS);
                    if ($s != "")
                    {
                      if ($PDQ_model != "")
                      {
                        $PDQ_model = $s;
                        $hist .= sprintf("SETNAME \"%s\"\n",$s);
                        $PDQSprompt = "PDQ>".$s."> ";
                        if ($showmessage) printf("  >> OK: Model name changed to: \"%s\"\n",$s);
                      } else {
                        if ($showerror) printf("  >> ERROR: Model not yet initialized use INIT to initialize.\n");
                      };
                    } else {
                      if ($showerror) printf("  >> ERROR: Invalid or empty model name!\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "PROMPT":
                    $s = Purify($cas);
                    $c = UpPurify($ca[1]);
                    switch ($c)
                    {
                      case "OFF": $showprompt = FALSE; $hist .= sprintf("PROMPT OFF\n"); break;
                      case "ON": $showprompt = TRUE; $hist .= sprintf("PROMPT ON\n"); break;
                      case "DEFAULT": $PDQSprompt = "PDQ> "; $hist .= sprintf("PROMPT DEFAULT\n"); break; 
                      case "COMPLETE": $PDQSprompt = trim($PDQSprompt)."> "; $hist .= sprintf("PROMPT COMPLETE\n"); break; 
                      default: $PDQSprompt = $s; $hist .= sprintf("PROMPT \"%s\"\n",$s);
                    };
                    $infiniteloop = 0;
                    break;
            case "MESSAGE":
            case "MESSAGES":
            case "SHOWMESSAGE":
                    $c = UpPurify($ca[1]);
                    switch ($c)
                    {
                      case "OFF": $showmessage = FALSE; break;
                      case "ON":  $showmessage = TRUE; break;
                      default: ($showmessage)?printf("  >> OK: Message reporting is ON\n"):printf("  >> OK: Message reporting is OFF\n"); $c = "";
                    };
                    $hist .= sprintf("MESSAGE %s\n",$c);
                    $infiniteloop = 0;
                    break;
            case "ERROR":
            case "ERRORS":
            case "SHOWERROR":
                    $c = UpPurify($ca[1]);
                    switch ($c)
                    {
                      case "OFF": $showerror = FALSE; break;
                      case "ON":  $showerror = TRUE; break;
                      default: ($showerror)?printf("  >> OK: Error reporting is ON\n"):printf("  >> OK: Error Reporting is OFF\n"); $c = "";
                    };
                    $hist .= sprintf("ERROR %s\n",$c);
                    $infiniteloop = 0;
                    break;
            case "ECHO":
            case "PRINT":
                    $s = Purify($cas);
                    printf("%s",$s);
                    $hist .= sprintf("PRINT \"%s\"\n",$s);
                    $infiniteloop = 0;
                    break;
            case "ECHON":
            case "PRINTN":
                    $s = Purify($cas);
                    printf("%s\n",$s);
                    $hist .= sprintf("PRINTN \"%s\"\n",$s);
                    $infiniteloop = 0;
                    break;
            case "VER":
            case "VERSION":
                    printf("%s\n",PDQ_GetVersion());
                    $hist .= sprintf("VERSION\n",$s);
                    $infiniteloop = 0;
                    break;
            case "SET":
            case "LET":
            case "VAR":
            case "INT":
            case "INTEGER":
            case "REAL":
            case "DOUBLE":
            case "FLOAT":
                    $s = UpPurify($ca[1]);
                    $c = UpPurify($ca[2]);
                    $f = UpPurify($ca[3]);
                    if (($s != "") && ($c == "=") && is_numeric($f))
                    {
                        $PML_Vars[$s] = (float) $f;
                        $hist .= sprintf("VAR %s = %f\n",$s,(float)$f);
                        if ($showmessage) printf("  >> OK: Variable %s defined with value %3.4f\n",$s,$f);
                    } else {
                        if ($showerror && ($c != "=")) printf("  >> ERROR: Variable syntax error use: %s %s = %3.4f\n",$comm,$s,$f);
                        if ($showerror && (!is_numeric($f))) printf("  >> ERROR: You try to define a non numeric variable %s\n",$s);
                    };
                    $infiniteloop = 0;
                    break;
            case "GETVAR":
            case "PRINTV":
            case "PRINTVAR":
            case "VARSHOW":
            case "SHOWVAR":
                    $s = UpPurify($ca[1]);
                    if ($s != "")
                    {
                        if (array_key_exists($s,$PML_Vars)) {
                            $hist .= sprintf("PRINTV %s\n",$s);
                            if ($showmessage) 
                            {
                              printf("  >> OK: Variable %s = %3.4f\n",$s,$PML_Vars[$s]);
                            } else {
                              printf("%3.4f",$PML_Vars[$s]);
                            };
                        } else {
                          if ($showerror) 
                          {
                            printf("  >> ERROR: Undefined variable %s\n",$s);
                          } else {
                            printf("UNDEFINED VARS");
                          };  
                        };
                    } else {
                      if ($showerror) printf("  >> ERROR: Missing variable name\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "VARSTAT":
                    if($showmessage) {
                        printf("  >> OK: Defined variables follow:\n");
                        $hist .= sprintf("VARSTAT\n");
                        foreach ($PML_Vars as $key => $value) {
                            printf("  >>     %s = %3.4f\n",$key,$value);
                        };
                    };
                    $infiniteloop = 0;
                    break;
            case "CO":
            case "COPEN":
            case "CREATEOPEN":
                    $s = UpPurify($ca[1]);
                    $pf = UpPurify($ca[2]);
                    $f = array_key_exists($pf,$PML_Vars) ? (float) $PML_Vars[$pf] : (float) $pf;
                    if (($s != "") && is_numeric($f))
                    {
                        $ws = PDQ_CreateOpen($s,$f);
                        $hist .= sprintf("CREATEOPEN \"%s\" %f\n",$s,$f);
                        $PML_Vars["CREATEOPENCOUNT"] += 1;
                        $solved = FALSE;
                        if ($showmessage)
                        {
                            printf("  >> OK: CREATEOPEN \"%s\" %3.4f\n",$s,$f);
                            printf("  >>     Total number of workload created = %d\n",$ws);
                        };
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty paraameters <s> = \"%s\" <f> = \"%3.4f\"\n",$s,$f);
                    };
                    $infiniteloop = 0;
                    break;
            case "CC":
            case "CCLOSED":
            case "CREATECLOSED":
                    $s = UpPurify($ca[1]);
                    $c = UpPurify($ca[2]);
                    $pf1 = UpPurify($ca[3]);
                    $pf2 = UpPurify($ca[4]);
                    $f1 = array_key_exists($pf1,$PML_Vars) ? (float) $PML_Vars[$pf1] : (float) $pf1;
                    $f2 = array_key_exists($pf2,$PML_Vars) ? (float) $PML_Vars[$pf2] : (float) $pf2;
                    if (($s != "") && in_array($c,array("BATCH","TERM")) && is_numeric($f1) && is_numeric($f2))
                    {
                        $ws = PDQ_CreateClosed($s,(($c == "BATCH")?BATCH:TERM),$f1,$f2);
                        $hist .= sprintf("CREATECLOSED \"%s\" %s %f %f\n",$s,$c,$f1,$f2);
                        $PML_Vars["CREATECLOSEDCOUNT"] += 1;
                        $solved = FALSE;
                        if ($showmessage) {
                            printf("  >> OK: CREATECLOSED \"%s\" %s %3.4f %3.4f\n",$s,$c,$f1,$f2);
                            printf("  >>     Total number of workload created = %d\n",$ws);
                        };
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty parameters <s> = \"%s\" <c> = \"%s\" <f1> = \"%3.4f\" <f2> = \"%3.4f\"\n",$s,$c,$f1,$f2);
                    };
                    $infiniteloop = 0;
                    break;
            case "CN":
            case "CNODE":
            case "CREATENODE":
            case "CREATESINGLENODE":
                    $s  = UpPurify($ca[1]);
                    $c1 = UpPurify($ca[2]);
                    $c2 = UpPurify($ca[3]);
                    if (($s != "") && in_array($c1,array("DLY","CEN")) && in_array($c2,$schedpol))
                    {
                        $ws = PDQ_CreateNode($s,$PDQ_typetable[$c1],$PDQ_typetable[$c2]);
                        $hist .= sprintf("CREATENODE \"%s\" %s %s\n",$s,$c1,$c2);
                        $PML_Vars["CREATENODECOUNT"] += 1;
                        $solved = FALSE;
                        if ($showmessage) {
                            printf("  >> OK: CREATENODE \"%s\" %s %s\n",$s,$c1,$c2);
                            printf("  >>     Total number of queueing node created = %d\n",$ws);
                        };
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty parameters <s> = \"%s\" <c1> = \"%s\" <c2> = \"%s\"\n",$s,$c1,$c2);
                    };
                    $infiniteloop = 0;
                    break;
            case "SD":
            case "SDEMAND":
            case "SETDEMAND":
                    $s = UpPurify($ca[1]);
                    $c = UpPurify($ca[2]);
                    $pf = UpPurify($ca[3]);
                    $f = array_key_exists($pf,$PML_Vars) ? (float) $PML_Vars[$pf] : (float) $pf;
                    if (($s != "") && ($c != "") && is_numeric($f))
                    {
                        PDQ_SetDemand($s,$c,$f);
                        $hist .= sprintf("SETDEMAND \"%s\" %s %f\n",$s,$c,$f);
                        $solved = FALSE;
                        if ($showmessage) printf("  >> OK: SETDEMAND \"%s\" \"%s\" %3.4f \n",$s,$c,$f);
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty parameters <s> = \"%s\" <c> = \"%s\" <f> = \"%3.4f\"\n",$s,$c,$f);
                    };
                    $infiniteloop = 0;
                    break;
            case "SV":
            case "SVISIT":
            case "SETVISIT":
            case "SETVISITS":
                    $s1 = UpPurify($ca[1]);
                    $s2 = UpPurify($ca[2]);
                    $pf1 = UpPurify($ca[3]);
                    $pf2 = UpPurify($ca[4]);
                    $f1 = array_key_exists($pf1,$PML_Vars) ? (float) $PML_Vars[$pf1] : (float) $pf1;
                    $f2 = array_key_exists($pf2,$PML_Vars) ? (float) $PML_Vars[$pf2] : (float) $pf2;
                    if (($s1 != "") && ($s2 != "") && is_numeric($f1) && is_numeric($f2))
                    {
                        PDQ_SetVisits($s1,$s2,$f1,$f2);
                        $hist .= sprintf("SETVISIT \"%s\" \"%s\" %f %f\n",$s1,$s2,$f1,$f2);
                        $solved = FALSE;
                        if ($showmessage) printf("  >> OK: SETVISIT \"%s\" \"%s\" %3.4f %3.4f\n",$s1,$s2,$f1,$f2);
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty paraameters <s1> = \"%s\" <s2> = \"%s\" <f1> = \"%3.4f\" <f2> = \"%3.4f\"\n",$s1,$s2,$f1,$f2);
                    };
                    $infiniteloop = 0;
                    break;
            case "SW":
            case "SWU":
            case "SWUNIT":
            case "SETWUNIT":
            case "SETWORKUNIT":
                    $s = Purify($ca[1]);
                    if ($s != "")
                    {
                      PDQ_SetWUnit($s);
                      $hist .= sprintf("SETWUNIT \"%s\"\n",$s);
                      if ($showmessage) printf("  >> OK: Work unit set to: \"%s\"\n",$s);
                    } else {
                      if ($showerror) printf("  >> ERROR: Invalid or empty work unit name!\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "ST":
            case "STU":
            case "STUNIT":
            case "SETTUNIT":
            case "SETTIMEUNIT":
                    $s = Purify($ca[1]);
                    if ($s != "")
                    {
                      PDQ_SetTUnit($s);
                      $hist .= sprintf("SETTUNIT \"%s\"\n",$s);
                      if ($showmessage) printf("  >> OK: Time unit set to: \"%s\"\n",$s);
                    } else {
                      if ($showerror) printf("  >> ERROR: Invalid or empty time unit name!\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "DBG":
            case "SDBG":
            case "DEBUG":
            case "SDEBUG":
            case "SETDEBUG":
                    $p1 = UpPurify($ca[1]); 
                    if (($p1 == "TRUE") || ($p1 == "FALSE"))
                    {
                        PDQ_SetDebug(($p1 == "TRUE")?TRUE:FALSE);
                        $hist .= sprintf("SETDEBUG %s\n",$p1);
                    } else {
                        if ($showerror) printf("  >> ERROR: Wrong parameter shoulb be TRUE or FALSE\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "SOLVE":
            case "COMPUTE":
                    $p1 = UpPurify($ca[1]); 
                    if (in_array($p1,array("APPROX","CANON","EXACT")))
                    {
                      if ( $PDQ_prev_init && ($PDQ_streams > 0) && ($PDQ_nodes > 0) )
                      {
                            PDQ_Solve($PDQ_typetable[$p1]);
                            $hist .= sprintf("SOLVE %s\n",$p1);
                            $solved = TRUE;
                            if ($showmessage) printf("  >> OK: Model solved.\n");
                      } else {
                          if ($showerror) printf("  >> ERROR: Model not initialized or workloads<0 or nodes<0.\n");  
                      };
                    } else {
                        if ($showerror) printf("  >> ERROR: Wrong parameter shoulb be one of APPROX, CANON or EXACT.\n");
                    };            
                    $infiniteloop = 0;
                    break;
            case "GR":
            case "GETRESPONSE":
                    $c = UpPurify($ca[1]);
                    $s = UpPurify($ca[2]);
                    if ($solved)
                    {
                        if (($s != "") && (in_array($c,array("TRANS","TERM","BATCH"))))
                        {
                            $srt = PDQ_GetResponse($c,$s);
                            $hist .= sprintf("GETRESPONSE %s \"%s\"\n",$c,$s);
                            $PML_Vars["RESPONSE"] = $srt;
                            if ($showmessage) {
                                printf("  >> OK: System Response Time for \"%s\" \"%s\" is = %3.4f\n",$c,$s,$srt);
                            } else {
                                printf("System Response Time = %3.4f (for %s of class %s)\n",$srt,$s,$c);
                            };
                        } else {
                            if ($showerror) printf("  >> ERROR: Invalid or empty parameters <c> = \"%s\" <s> = \"%s\"\n",$c,$s);
                        };
                    } else {
                        if ($showerror) printf("  >> ERROR: Model not yet solved. Use SOLVE <method> to solve the model.\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "GT":
            case "GETTHRUPUT":
                    $c = UpPurify($ca[1]);
                    $s = UpPurify($ca[2]);
                    if ($solved)
                    {
                        if (($s != "") && (in_array($c,array("TRANS","TERM","BATCH"))))
                        {
                            $stp = PDQ_GetThruput($c,$s);
                            $hist .= sprintf("GETTHRUPUT %s \"%s\"\n",$c,$s);
                            $PML_Vars["THRUPUT"] = $stp;
                            if ($showmessage) {
                              printf("  >> OK: System Thruput for \"%s\" \"%s\" is = %3.4f\n",$c,$s,$stp);
                            } else {
                              printf("System Thruput = %3.4f (for %s of class %s)\n",$stp,$s,$c);
                            };
                        } else {
                            if ($showerror) printf("  >> ERROR: Invalid or empty parameters <c> = \"%s\" <s> = \"%s\"\n",$c,$s);
                        };
                    } else {
                        if ($showerror) printf("  >> ERROR: Model not yet solved. Use SOLVE <method> to solve the model.\n");
                    };
                    $infiniteloop = 0;
                    break;
            case "GU":
            case "GETUTILIZATION":
                    $s1 = UpPurify($ca[1]);
                    $s2 = UpPurify($ca[2]);
                    if ($solved)
                    {
                        if (($s1 != "") && ($s2 != ""))
                        {
                            $utl = PDQ_GetUtilization($s1,$s2);
                            $hist .= sprintf("GETUTILIZATION \"%s\" \"%s\"\n",$s1,$s2);
                            $PML_Vars["UTILIZATION"] = $utl;
                            if ($showmessage) {
                                printf("  >> OK: System Utilization for \"%s\" \"%s\" is = %3.4f\n",$s1,$s2,$utl);
                            } else {
                                printf("System Utilization = %3.4f (Dev: %s Work: %s)\n",$utl,$s1,$s2);
                            };
                        } else {
                            if ($showerror) printf("  >> ERROR: Invalid or empty parameters <s1> = \"%s\" <s2> = \"%s\"\n",$s1,$s2);
                        };
                    } else {
                        if ($showerror) printf("  >> ERROR: Model not yet solved. Use SOLVE <method> to solve the model.\n");
                    };
                    $infiniteloop = 0;
                   break;
            case "REP":
            case "REPORT":
                    if ($solved)
                    {
                      if ( $PDQ_prev_init && ($PDQ_streams > 0) && ($PDQ_nodes > 0) )
                      {
                            if ($showmessage) printf("  >> Printing Report:\n");
                            PDQ_Report();
                            $hist .= sprintf("REPORT\n");
                      } else {
                          if ($showerror) printf("  >> ERROR: Model not initialized or workloads<0 or nodes<0.\n");  
                      };
                    } else {
                        if ($showerror) printf("  >> ERROR: Model not yet solved. Use SOLVE <method> to solve the model.\n");
                    };            
                    $infiniteloop = 0;
                    break;
            case "SREP":
            case "SMARTREPORT":
            case "SREPORT":
                    if ($solved)
                    {
                      if ( $PDQ_prev_init && ($PDQ_streams > 0) && ($PDQ_nodes > 0) )
                      {
                            if ($showmessage) printf("  >> Printing Smart Report:\n");
                            PDQ_SmartReport();
                            $hist .= sprintf("SMARTREPORT\n");
                      } else {
                          if ($showerror) printf("  >> ERROR: Model not initialized or workloads<0 or nodes<0.\n");  
                      };
                    } else {
                        if ($showerror) printf("  >> ERROR: Model not yet solved. Use SOLVE <method> to solve the model.\n");
                    };            
                    $infiniteloop = 0;
                    break;
            case "?":
            case "H":
            case "HELP":
                    help();
                    $infiniteloop = 0;
                    break;
            case "HIST":
            case "HISTORY":
            case "SHOWHIST":
                    printf("\nCommands History:\n\n%s\n",$hist);
                    $infiniteloop = 0;
                    break;
            case "CLEARHIST":
            case "CLEARHISTORY":
                    $hist = "";
                    if ($showmessage) printf("  >> OK History Cleared\n");
                    $infiniteloop = 0;
                    break;
            case "??":
            case "HH":
            case "EXTHELP":
                    exthelp();
                    $infiniteloop = 0;
                    break;
            case "XIT":
            case "END":
            case "BYE":
            case "QUIT":
            case "EXIT":
            case "LOGOUT":
                    $comm = "EXIT";
                    if ($showmessage) printf("\nThank you for using PDQ Performance Analyzer Shell. Bye!\n");
                    $infiniteloop = 0;
                    break;
            case "":
            case "//":
            case "/*":
            case "*":
            case "#":
            case "{":
            case "}":
            case "[":
            case "]":
            case "ARC":
            case "TRANSIT":
                    break;
            case "MAIN":
            case "MAIN:":
            case "BEGIN":
            case "BEGIN:":
            case "START":
            case "START:":
                    $hist .= sprintf("MAIN\n");
                    $infiniteloop = 0;
                    break;
            case "CIAO":
            case "HOLA":
            case "HALLO":
            case "HELLO":
            case "BONJOUR":
                    printf("  >> OK: %s!\n",$comm);
                    $infiniteloop = 0;
                    break;
            case "REPAIR":
                    $pf1 = UpPurify($ca[1]);
                    $pf2 = UpPurify($ca[2]);
                    $pf3 = UpPurify($ca[3]);
                    $pf4 = UpPurify($ca[4]);
                    $f1 = array_key_exists($pf1,$PML_Vars) ? (float) $PML_Vars[$pf1] : (float) $pf1;
                    $f2 = array_key_exists($pf2,$PML_Vars) ? (float) $PML_Vars[$pf2] : (float) $pf2;
                    $f3 = array_key_exists($pf3,$PML_Vars) ? (float) $PML_Vars[$pf3] : (float) $pf3;
                    $f4 = array_key_exists($pf4,$PML_Vars) ? (float) $PML_Vars[$pf4] : (float) $pf4;
                    if (is_numeric($f1) && is_numeric($f2) && is_numeric($f3) && is_numeric($f4))
                    {
                        if ($showmessage) printf("  >> OK: REPAIR %3.4f %3.4f %3.4f %3.4f \n",$f1,$f2,$f3,$f4);
                        PDQ_Repair($f1,$f2,$f3,$f4);
                        $hist .= sprintf("REPAIR %f %f %f %f\n",$f1,$f2,$f3,$f4);
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty paraameters <f1> = \"%3.4f\" <f2> = \"%3.4f\" <f3> = \"%3.4f\" <f4> = \"%3.4f\"\n",$f1,$f2,$f3,$f4);
                    };
                    $infiniteloop = 0;
                    break;
            case "ERLANG":
                    $pf1 = UpPurify($ca[1]);
                    $pf2 = UpPurify($ca[2]);
                    $f1 = array_key_exists($pf1,$PML_Vars) ? (float) $PML_Vars[$pf1] : (float) $pf1;
                    $f2 = array_key_exists($pf2,$PML_Vars) ? (float) $PML_Vars[$pf2] : (float) $pf2;
                    if (is_numeric($f1) && is_numeric($f2))
                    {
                        if ($showmessage) printf("  >> OK: ERLANG %3.4f %3.4f \n",$f1,$f2);
                        PDQ_Erlang($f1,$f2);
                        $hist .= sprintf("ERLANG %f %f\n",$f1,$f2);
                    } else {
                        if ($showerror) printf("  >> ERROR: Invalid or empty paraameters <f1> = \"%3.4f\" <f2> = \"%3.4f\"\n",$f1,$f2);
                    };
                    $infiniteloop = 0;
                    break;

            default:
                if ($showerror) printf("  >> ERROR: Unimplemented or unknown command: \"$comm\"\n");
        }; // case
        $infiniteloop += 1;
        if ($infiniteloop > 50) 
        {
          $comm = "EXIT";
          printf("\nPDQ SHELL CRITICAL ERROR!! Infinite loop detected.\n");
        };
        if (feof($fin)) $comm = "EXIT";
        
    }; // while
    if ($notstdin) fclose($fin);
};
main($argc, $argv);
?>